/*
 * Copyright (c) 2002, 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: strgetsize.c,v 1.3 2005/06/02 19:00:37 ca Exp $")

#include "sm/assert.h"
#include "sm/magic.h"
#include "sm/rpool.h"
#include "sm/strrcb.h"
#include "sm/str-int.h"
#include "sm/str2rcb.h"

#if SM_STR_CHECK
/*
**  SM_STR_GETSIZE -- Returns the current size of str.
**
**	Parameters:
**		str -- sm_str_P object.
**
**	Returns:
**		Size of allocated buffer.
*/

uint
sm_str_getsize(sm_str_P str)
{
	SM_IS_BUF(str);
	return str->sm_str_size;
}
#endif /* SM_STR_CHECK */
